#ifndef MISSILE_H_
#define MISSILE_H_

#include "Target.h"
#include "Snake.h"

class Missile :
    public Star
{
public:
    Missile(float radius, float x, float y, float z, float xt, float yt, float zt, int pl, World * w);
    ~Missile(void);

    int age;

    struct TailItem
    {
        float p[3];
    };

    int tailOrigin;
    int tailLength;
    struct TailItem tail[TAIL_LENGTH];
    void translateTail();

    void reset(World * w);
    void update(World * w);
    void draw(World * w);

    int explosionFactor;
    bool isAlive;
    int drivebySound;
    bool isAtImpact(World * w);
    bool checkAllTargetsForImpact(World * w);
    //void bounceOnHeadIfCollision(World * w);
    void bounceIfCollision(World * w);
    void explode(World * w);

    float c3[4];
};

#endif