#ifndef TUNNEL_H_
#define TUNNEL_H_

class Tunnel
{
public:
    Tunnel();
    ~Tunnel(void);

    static void init(Tunnel * tunnels, float radiusE, float radiusI, World * w, int n);
    void projectOnTunnelD(World * w);

    float * axis;
    float radiusExt, radiusInt, radiusCurve, xC, yC;

private:
    enum position {Out, On, In};


    void projectOnTunnel(int index, int * bv, int & nbv); //, int & v);
    static bool isBottomFace(Sphere::Triangle * face, int * bv, int nbv); //, int * collec, int & nc, int depth);
    static void addBottomVertice(int x, int * v, int & n);
    static void removeBottomFaces(Sphere::Triangle * face, int * bv, int nbv); //, int * collec, int & n, int depth);
    static void sortCylinderVertices(int * index, int * bv, int nbv);
    static void sortCylinderVertices(int * v, int n);
    static int closestVertice(int i, int * index, int j, int * bv, int nbv);
    void setFields(int * vertices, float radiusE, float radiusI);
    void localNormal(float * p, float xQ, float yQ, float * n);
    position toLocalCoordonates(float * p, float & x, float & y);
};

#endif